Index: XIOS/trunk/src/node/domain.hpp
===================================================================
--- XIOS/trunk/src/node/domain.hpp	(revision 2109)
+++ XIOS/trunk/src/node/domain.hpp	(revision 2131)
@@ -104,5 +104,13 @@
          bool isDistributed(void) const;
          bool isCompressible(void) const; 
- 
+
+         bool isTiled(void) const;
+         bool isTiledOnly(void) const;
+         int getTileId(int i, int j) const;
+         int getTileDataISize(int tileId) const;
+         int getTileDataJSize(int tileId) const;
+         void computeCompressionTiled(CArray<int,1>& dataIndexI, CArray<int,1>& dataIndexJ,
+                                      CArray<int,1>& infoIndexI, CArray<int,1>& infoIndexJ);
+
          std::vector<int> getNbGlob();
          bool isEqual(CDomain* domain);
@@ -170,4 +178,5 @@
          void checkArea(void);
          void checkLonLat();
+         void checkTiles();
 
          void setTransformations(const TransMapTypes&);         
@@ -223,5 +232,5 @@
          std::map<int, std::vector<int> > connectedServerRank_;
 
-         //! True if and only if the data defined on the domain can be outputted in a compressed way
+//! True if and only if the data defined on the domain can be outputted in a compressed way
          bool isCompressible_;
          bool isRedistributed_;
@@ -229,5 +238,10 @@
          bool isUnstructed_;
          std::unordered_map<size_t,size_t> globalLocalIndexMap_;
-       
+
+//! True if tiled data is defined on the domain
+         bool isTiled_;
+//! True if ONLY tiled data is defined on the domain
+         bool isTiledOnly_;
+
        private:
          static bool initializeTransformationMap(std::map<StdString, ETranformationType>& m);
Index: XIOS/trunk/src/node/field.cpp
===================================================================
--- XIOS/trunk/src/node/field.cpp	(revision 2109)
+++ XIOS/trunk/src/node/field.cpp	(revision 2131)
@@ -2059,5 +2059,5 @@
      {
        //if(file->output_freq.getValue() < freq_op.getValue())
-       if((isFieldRead || isFieldWrite) && (freq_op.getValue() > file->output_freq.getValue()) )
+       if((isFieldRead || isFieldWrite) && (file!=nullptr) && (freq_op.getValue() > file->output_freq.getValue() ))
        {
          ERROR("void CField::checkTimeAttributes(void)",
Index: XIOS/trunk/src/node/field.hpp
===================================================================
--- XIOS/trunk/src/node/field.hpp	(revision 2109)
+++ XIOS/trunk/src/node/field.hpp	(revision 2131)
@@ -160,5 +160,5 @@
          static ENodeType GetType(void);
 
-        template <int N> void setData(const CArray<double, N>& _data);
+        template <int N> void setData(const CArray<double, N>& _data, int ntile = -1);
         static bool dispatchEvent(CEventServer& event);
         void sendAllAttributesToServer(CContextClient* client) ; 
Index: XIOS/trunk/src/node/field_decl.cpp
===================================================================
--- XIOS/trunk/src/node/field_decl.cpp	(revision 2109)
+++ XIOS/trunk/src/node/field_decl.cpp	(revision 2131)
@@ -3,11 +3,11 @@
 namespace xios
 {
-  template void CField::setData<1>(const CArray<double, 1>& _data);
-  template void CField::setData<2>(const CArray<double, 2>& _data);
-  template void CField::setData<3>(const CArray<double, 3>& _data);
-  template void CField::setData<4>(const CArray<double, 4>& _data);
-  template void CField::setData<5>(const CArray<double, 5>& _data);
-  template void CField::setData<6>(const CArray<double, 6>& _data);
-  template void CField::setData<7>(const CArray<double, 7>& _data);
+  template void CField::setData<1>(const CArray<double, 1>& _data, int ntile);
+  template void CField::setData<2>(const CArray<double, 2>& _data, int ntile);
+  template void CField::setData<3>(const CArray<double, 3>& _data, int ntile);
+  template void CField::setData<4>(const CArray<double, 4>& _data, int ntile);
+  template void CField::setData<5>(const CArray<double, 5>& _data, int ntile);
+  template void CField::setData<6>(const CArray<double, 6>& _data, int ntile);
+  template void CField::setData<7>(const CArray<double, 7>& _data, int ntile);
 
   template void CField::getData<1>(CArray<double, 1>& _data) const;
Index: XIOS/trunk/src/node/field_impl.hpp
===================================================================
--- XIOS/trunk/src/node/field_impl.hpp	(revision 2109)
+++ XIOS/trunk/src/node/field_impl.hpp	(revision 2131)
@@ -16,5 +16,5 @@
 
   template <int N>
-  void CField::setData(const CArray<double, N>& _data)
+  void CField::setData(const CArray<double, N>& _data, int tileid)
   TRY
   {
@@ -22,5 +22,8 @@
     {
       if (check_if_active.isEmpty() || (!check_if_active.isEmpty() && (!check_if_active) || isActive(true)))
-        clientSourceFilter->streamData(CContext::getCurrent()->getCalendar()->getCurrentDate(), _data);
+        if (tileid > -1)
+          clientSourceFilter->streamTile(CContext::getCurrent()->getCalendar()->getCurrentDate(), _data, tileid); // tiled domain
+        else
+          clientSourceFilter->streamData(CContext::getCurrent()->getCalendar()->getCurrentDate(), _data);
     }
     else if (instantDataFilter)
Index: XIOS/trunk/src/node/grid.cpp
===================================================================
--- XIOS/trunk/src/node/grid.cpp	(revision 2109)
+++ XIOS/trunk/src/node/grid.cpp	(revision 2131)
@@ -39,4 +39,7 @@
       , computedWrittenIndex_(false)
       , clients()
+      , nTiles_(0)
+      , isTiled_(false), isTiledOnly_(false)
+      , storeTileIndex()
    {
      setVirtualDomainGroup(CDomainGroup::create(getId() + "_virtual_domain_group"));
@@ -60,4 +63,7 @@
       , computedWrittenIndex_(false)
       , clients()
+      , nTiles_(0)
+      , isTiled_(false), isTiledOnly_(false)
+      , storeTileIndex()
    {
      setVirtualDomainGroup(CDomainGroup::create(getId() + "_virtual_domain_group"));
@@ -102,4 +108,74 @@
    }
    CATCH
+
+   //---------------------------------------------------------------
+   /*!
+    * Returns size of tile data
+    */
+
+   StdSize CGrid::getTileDataSize(int tileId)
+   TRY
+   {
+     StdSize tileGridSize =1 ;
+     int numElement = axis_domain_order.numElements();
+
+     std::vector<CAxis*> axisListP = this->getAxis();
+     std::vector<CDomain*> domainListP = this->getDomains();
+
+     int axisIndex = 0, domIndex = 0;
+     for (int idx = 0; idx < numElement; ++idx)
+     {
+       int eleDim = axis_domain_order(idx);
+       if (2 == eleDim)
+       {
+         tileGridSize *= domainListP[domIndex]->tile_data_ni(tileId);
+         tileGridSize *= domainListP[domIndex]->tile_data_nj(tileId);
+         ++domIndex;
+          }
+       else if (1 == eleDim)
+       {
+         tileGridSize *= axisListP[axisIndex]->n.getValue();
+         ++axisIndex;
+       }
+     } // loop over grid elements
+     return tileGridSize;
+   }
+   CATCH
+
+   //---------------------------------------------------------------
+   /*!
+    * Returns tile size
+    */
+
+   StdSize CGrid::getTileSize(int tileId)
+   TRY
+   {
+     StdSize tileGridSize =1 ;
+     int numElement = axis_domain_order.numElements();
+
+     std::vector<CAxis*> axisListP = this->getAxis();
+     std::vector<CDomain*> domainListP = this->getDomains();
+
+     int axisIndex = 0, domIndex = 0;
+     for (int idx = 0; idx < numElement; ++idx)
+     {
+       int eleDim = axis_domain_order(idx);
+       if (2 == eleDim)
+       {
+         tileGridSize *= domainListP[domIndex]->tile_ni(tileId);
+         tileGridSize *= domainListP[domIndex]->tile_nj(tileId);
+         ++domIndex;
+          }
+       else if (1 == eleDim)// So it's an axis
+       {
+         tileGridSize *= axisListP[axisIndex]->n.getValue();
+         ++axisIndex;
+       }
+     } // loop over grid elements
+     return tileGridSize;
+   }
+   CATCH
+
+   //---------------------------------------------------------------
 
    /*!
@@ -561,4 +637,6 @@
           if (sendAtt) domListP[i]->sendCheckedAttributes();
           else domListP[i]->checkAttributesOnClient();
+          if (domListP[i]->isTiled()) this->isTiled_ = true;
+          if (domListP[i]->isTiledOnly()) this->isTiledOnly_ = true;
         }
       }
@@ -725,4 +803,76 @@
           outLocalIndexStoreOnClient.insert(make_pair(rank, CArray<size_t,1>(globalIndex.numElements())));
           CArray<size_t,1>& localIndex = outLocalIndexStoreOnClient[rank];
+          size_t nbIndex = 0;
+
+          // Keep this code for this moment but it should be removed (or moved to DEBUG) to improve performance
+          for (size_t idx = 0; idx < globalIndex.numElements(); ++idx)
+          {
+            if (itGloe != globalDataIndex.find(globalIndex(idx)))
+            {
+              ++nbIndex;
+            }
+          }
+
+          if (doGridHaveDataDistributed(client) && (nbIndex != localIndex.numElements()))
+               ERROR("void CGrid::computeClientIndex()",
+                  << "Number of local index on client is different from number of received global index"
+                  << "Rank of sent client " << rank <<"."
+                  << "Number of local index " << nbIndex << ". "
+                  << "Number of received global index " << localIndex.numElements() << ".");
+
+          nbIndex = 0;
+          for (size_t idx = 0; idx < globalIndex.numElements(); ++idx)
+          {
+            if (itGloe != globalDataIndex.find(globalIndex(idx)))
+            {
+              localIndex(idx) = globalDataIndex[globalIndex(idx)];
+            }
+          }
+        }
+      }
+   }
+   CATCH_DUMP_ATTR
+
+   //---------------------------------------------------------------
+
+   /*
+     Compute the global index and its local index taking account mask and data index.
+     These global indexes will be used to compute the connection of this client (sender) to its servers (receivers)
+     (via function computeConnectedClient)
+     These global indexes also correspond to data sent to servers (if any)
+   */
+   void CGrid::computeClientIndexTiled()
+   TRY
+   {
+     CContext* context = CContext::getCurrent();
+
+     CContextClient* client = context->client;
+     int rank = client->clientRank;
+
+     clientDistributionTiled_ = new CDistributionClient(rank, this, true);
+     // Get local data index on client
+     int nbStoreIndex = clientDistributionTiled_->getLocalDataIndexOnClient().size();
+     int nbStoreGridMask = clientDistributionTiled_->getLocalMaskIndexOnClient().size();
+     // nbStoreGridMask = nbStoreIndex if grid mask is defined, and 0 otherwise
+     storeIndexTiled_client.resize(nbStoreIndex);
+     storeMaskTiled_client.resize(nbStoreGridMask);
+     for (int idx = 0; idx < nbStoreIndex; ++idx) storeIndexTiled_client(idx) = (clientDistributionTiled_->getLocalDataIndexOnClient())[idx];
+     for (int idx = 0; idx < nbStoreGridMask; ++idx) storeMaskTiled_client(idx) = (clientDistributionTiled_->getLocalMaskIndexOnClient())[idx];
+
+     if (0 == serverDistribution_) isDataDistributed_= clientDistributionTiled_->isDataDistributed();
+     else
+     {
+        // Mapping global index received from clients to the storeIndex_client
+        CDistributionClient::GlobalLocalDataMap& globalDataIndex = clientDistributionTiled_->getGlobalDataIndexOnClient();
+        CDistributionClient::GlobalLocalDataMap::const_iterator itGloe = globalDataIndex.end();
+        map<int, CArray<size_t, 1> >::iterator itb = outGlobalIndexFromClientTiled.begin(),
+                                               ite = outGlobalIndexFromClientTiled.end(), it;
+
+        for (it = itb; it != ite; ++it)
+        {
+          int rank = it->first;
+          CArray<size_t,1>& globalIndex = outGlobalIndexFromClientTiled[rank];
+          outLocalIndexStoreOnClientTiled.insert(make_pair(rank, CArray<size_t,1>(globalIndex.numElements())));
+          CArray<size_t,1>& localIndex = outLocalIndexStoreOnClientTiled[rank];
           size_t nbIndex = 0;
 
@@ -901,5 +1051,14 @@
      else
      {
-       computeClientIndex();
+       if (this->isTiled_)
+       {
+         computeClientIndexTiled();
+         if (!this->isTiledOnly_)
+           computeClientIndex();
+       }
+       else
+         computeClientIndex();
+
+       if (this->isTiled_) computeTileIndex();
        if (context->hasClient)
        {
@@ -1097,4 +1256,111 @@
    }
    CATCH_DUMP_ATTR
+
+   //---------------------------------------------------------------
+
+   /*
+   */
+   void CGrid::computeTileIndex()
+   TRY
+   {
+     int numElement = axis_domain_order.numElements();
+     storeTileIndex.resize(nTiles_);
+
+     std::vector<CAxis*> axisListP = this->getAxis();
+     std::vector<CDomain*> domainListP = this->getDomains();
+
+     // First, allocate storeTileIndex[0..ntiles]
+     for (int iTile = 0; iTile < nTiles_; ++iTile)
+     {
+       int tileGridSize = 1;
+       int axisIndex = 0, domIndex = 0;
+       for (int idx = 0; idx < numElement; ++idx)
+       {
+         int eleDim = axis_domain_order(idx);
+         if (2 == eleDim)
+         {
+           tileGridSize *= domainListP[domIndex]->getTileDataISize(iTile);
+           tileGridSize *= domainListP[domIndex]->getTileDataJSize(iTile);
+           ++domIndex;
+         }
+         else if (1 == eleDim)// So it's an axis
+         {
+           tileGridSize *= axisListP[axisIndex]->n.getValue();
+           ++axisIndex;
+         }
+       } // loop over grid elements
+       storeTileIndex[iTile].resize(tileGridSize);
+       storeTileIndex[iTile] = -1;
+     } // loop over tiles
+
+     // Now fill in storeTileIndex
+     // Currently assuming two possible situations : (1) domain x axis or (2) domain
+     std::vector<int> tileIndexCount (nTiles_,0);
+     int axisSize = 1;
+     if (axisListP.size() != 0) axisSize = axisListP[0]->n.getValue();
+     int ni = domainListP[0]->ni.getValue();
+     int nj = domainListP[0]->nj.getValue();
+
+     for (int idxAxis = 0; idxAxis < axisSize; ++idxAxis)
+     {
+       for (int jIdxDom = 0; jIdxDom < nj; ++jIdxDom)
+       {
+         for (int iIdxDom = 0; iIdxDom < ni; ++iIdxDom)
+         {
+           int tile = domainListP[0]->getTileId(iIdxDom, jIdxDom);
+           int tileOffset =  domainListP[0]->tile_data_ibegin(tile);  // only sign of offset matters
+
+           // case 1: data size corresponds to tile size
+           if (tileOffset == 0)
+           {
+             storeTileIndex[tile](tileIndexCount[tile]) = idxAxis*nj*ni + jIdxDom * ni + iIdxDom;
+             ++tileIndexCount[tile];
+           }
+           // case 2: masked data
+           else if (tileOffset > 0)
+           {
+             int iBegin = domainListP[0]->tile_ibegin(tile) + domainListP[0]->tile_data_ibegin(tile); // tile data relative to domain
+             int jBegin = domainListP[0]->tile_jbegin(tile) + domainListP[0]->tile_data_jbegin(tile); // tile data relative to domain
+             int iEnd = iBegin + domainListP[0]->tile_data_ni(tile);
+             int jEnd = jBegin + domainListP[0]->tile_data_nj(tile);
+             if ((jIdxDom >= jBegin) && (jIdxDom < jEnd) && (iIdxDom >= iBegin) && (iIdxDom < iEnd))
+             {
+               storeTileIndex[tile](tileIndexCount[tile]) = idxAxis*nj*ni + jIdxDom * ni + iIdxDom;
+             }
+             ++tileIndexCount[tile];
+           }
+           // case 3: ghost zones
+           else
+           {
+             int tileDataNi = domainListP[0]->tile_data_ni(tile);
+             int tileDataNj = domainListP[0]->tile_data_nj(tile);
+             int tileDomSize = tileDataNi * tileDataNj;
+             int tileNi = domainListP[0]->tile_ni(tile);
+             int iBegin = domainListP[0]->tile_data_ibegin(tile);
+             int jBegin = domainListP[0]->tile_data_jbegin(tile);
+
+             // add the ghost zone at the beginning of a domain tile
+             if (tileIndexCount[tile] % tileDomSize == 0)
+               tileIndexCount[tile] += (abs(jBegin)*tileDataNi + abs(iBegin));
+
+             storeTileIndex[tile](tileIndexCount[tile]) = idxAxis*nj*ni + jIdxDom*ni + iIdxDom;
+             
+             // add two ghost zones at the right end of a tile
+             if ( (iIdxDom+1) % tileNi == 0 )
+               tileIndexCount[tile] += (2*abs(iBegin));
+
+             // add ghost zone at the end of a domain tile
+             if ((tileIndexCount[tile] + abs(jBegin)*tileDataNi-abs(iBegin) + 1) % tileDomSize == 0)
+               tileIndexCount[tile] += (abs(jBegin)*tileDataNi -abs(iBegin));
+
+             ++tileIndexCount[tile];
+           }
+         } // loop over domain first dimension
+       } // loop over domain second dimension
+     } // loop over axis dimension
+
+   }
+   CATCH_DUMP_ATTR
+
 //----------------------------------------------------------------
 
@@ -1358,15 +1624,55 @@
    CATCH
 
-   void CGrid::maskField_arr(const double* const data, CArray<double, 1>& stored) const
-   {
-      const StdSize size = storeIndex_client.numElements();
+   void CGrid::maskField_arr(const double* const data, CArray<double, 1>& stored, bool isTiled) const
+   TRY
+   {
+      const CArray<int, 1>& storeIndex_clientP = isTiled ? storeIndexTiled_client : storeIndex_client;
+      const CArray<bool, 1>& storeMask_clientP = isTiled ? storeMaskTiled_client : storeMask_client;
+      const StdSize size = storeIndex_clientP.numElements();
       stored.resize(size);
       const double nanValue = std::numeric_limits<double>::quiet_NaN();
 
-      if (storeMask_client.numElements() != 0)
-        for(StdSize i = 0; i < size; i++) stored(i) = (storeMask_client(i)) ? data[storeIndex_client(i)] : nanValue;
+      if (storeMask_clientP.numElements() != 0)
+        for(StdSize i = 0; i < size; i++) stored(i) = (storeMask_clientP(i)) ? data[storeIndex_clientP(i)] : nanValue;
       else
-        for(StdSize i = 0; i < size; i++) stored(i) = data[storeIndex_client(i)];
-   }
+        for(StdSize i = 0; i < size; i++) stored(i) = data[storeIndex_clientP(i)];
+   }
+   CATCH
+
+   void CGrid::copyTile_arr(const double* const tileData, CArray<double, 1>& stored, int tileId)
+   TRY
+   {
+     StdSize tileSize = this->getTileSize(tileId);
+     const StdSize tileDataSize = this->getTileDataSize(tileId);
+
+     // case 1: data correspond in size to a tile
+     if (tileSize == tileDataSize)
+     {
+       for(StdSize i = 0; i < tileDataSize; i++)
+         stored(storeTileIndex[tileId](i)) = tileData[i];
+     }
+     // case 2: masked data
+     else if (tileSize > tileDataSize)
+     {
+       int tileDataCount = 0;
+       for(StdSize i = 0; i < tileSize; i++)
+         if (storeTileIndex[tileId](i) >= 0)
+         {
+           stored(storeTileIndex[tileId](i)) = tileData[tileDataCount];
+           ++tileDataCount;
+         }
+     }
+     // case 3: ghost zones
+     else
+     {
+       for(StdSize i = 0; i < tileDataSize; i++)
+         if (storeTileIndex[tileId](i) >= 0)
+         {
+           stored(storeTileIndex[tileId](i)) = tileData[i];
+         }
+
+     }
+   }
+   CATCH
 
    void CGrid::uncompressField_arr(const double* const data, CArray<double, 1>& out) const
@@ -2253,4 +2559,5 @@
         pDom->solveRefInheritance(apply);
         pDom->solveInheritanceTransformation();
+        if (!pDom->ntiles.isEmpty() && pDom->ntiles.getValue()>0) nTiles_=pDom->ntiles.getValue();
       }
     }
@@ -2281,4 +2588,25 @@
   }
   CATCH_DUMP_ATTR
+
+  int CGrid::getNTiles()
+  TRY
+  {
+    return nTiles_;
+  }
+  CATCH_DUMP_ATTR
+
+  bool CGrid::isTiled(void) const
+  TRY
+  {
+     return isTiled_;
+  }
+  CATCH
+
+  bool CGrid::isTiledOnly(void) const
+  TRY
+  {
+     return isTiledOnly_;
+  }
+  CATCH
 
   bool CGrid::isTransformed()
Index: XIOS/trunk/src/node/grid.hpp
===================================================================
--- XIOS/trunk/src/node/grid.hpp	(revision 2109)
+++ XIOS/trunk/src/node/grid.hpp	(revision 2131)
@@ -91,13 +91,19 @@
          StdSize  getDataSize(void) const;
 
+         StdSize  getTileDataSize(int tileId);
+
+         StdSize  getTileSize(int tileId);
+
          /// Entrees-sorties de champs
          template <int n>
          void inputField(const CArray<double,n>& field, CArray<double,1>& stored) const;
          template <int n>
-         void maskField(const CArray<double,n>& field, CArray<double,1>& stored) const;
+         void maskField(const CArray<double,n>& field, CArray<double,1>& stored, bool isTiled = false) const;
          template <int n>
          void outputField(const CArray<double,1>& stored, CArray<double,n>& field) const;  
          template <int n>
          void uncompressField(const CArray<double,n>& data, CArray<double,1>& outData) const; 
+         template <int n>
+         void copyTile(const CArray<double,n>& tileData, CArray<double, 1>& stored, int tileId);
 
          virtual void parse(xml::CXMLNode& node);
@@ -205,5 +211,7 @@
       public:
          CArray<int, 1> storeIndex_client;
+         CArray<int, 1> storeIndexTiled_client;
          CArray<bool, 1> storeMask_client;
+         CArray<bool, 1> storeMaskTiled_client;
 
 /** Map containing indexes that will be sent in sendIndex(). */
@@ -223,4 +231,7 @@
 /** Map storing received indexes. Key = sender rank, value = index array. */
          map<int, CArray<size_t, 1> > outGlobalIndexFromClient;
+
+/** Map storing received indexes. Key = sender rank, value = index array for tiled domains */
+         map<int, CArray<size_t, 1> > outGlobalIndexFromClientTiled;
 
 // Manh Ha's comment: " A client receives global index from other clients (via recvIndex)
@@ -232,4 +243,9 @@
  *  The map is created in CGrid::computeClientIndex and filled upon receiving data in CField::recvUpdateData() */
          map<int, CArray<size_t, 1> > outLocalIndexStoreOnClient; 
+
+/** Map storing received data. Key = sender rank, value = data array.
+ *  The map is created in CGrid::computeClientIndex and filled upon receiving data in CField::recvUpdateData() */
+         map<int, CArray<size_t, 1> > outLocalIndexStoreOnClientTiled;
+
 
 /** Indexes calculated based on server-like distribution.
@@ -255,4 +271,8 @@
                                          const std::vector<CScalar*>& scalars,
                                          const CArray<int,1>& axisDomainOrder);
+
+         int getNTiles();
+         bool isTiled(void) const;
+         bool isTiledOnly(void) const;
 
       private:
@@ -272,5 +292,6 @@
         void restoreField_arr(const CArray<double, 1>& stored, double* const data) const;
         void uncompressField_arr(const double* const data, CArray<double, 1>& outData) const;
-        void maskField_arr(const double* const data, CArray<double, 1>& stored) const;
+        void maskField_arr(const double* const data, CArray<double, 1>& stored, bool isTiled = false) const;
+        void copyTile_arr(const double* const tileData, CArray<double, 1>& stored, int tileId);
 
         void setVirtualDomainGroup(CDomainGroup* newVDomainGroup);
@@ -299,8 +320,11 @@
 
         void computeClientIndex();
+        void computeClientIndexTiled();
         void computeConnectedClients();
         void computeClientIndexScalarGrid(); 
         void computeConnectedClientsScalarGrid(); 
 
+        void computeTileIndex();
+
       private:
 
@@ -312,4 +336,13 @@
         bool isDomainAxisChecked;
         bool isIndexSent;
+
+        int nTiles_;
+/** True if tiled data is defined on the grid */
+        bool isTiled_;
+/** True if ONLY tiled data is defined on the grid */
+        bool isTiledOnly_;
+
+/** Vector containing local domain indexes for each tile */
+        std::vector<CArray<int,1> > storeTileIndex;
 
         CDomainGroup* vDomainGroup_;
@@ -321,4 +354,8 @@
 /** Client-like distribution calculated based on the knowledge of the entire grid */
         CDistributionClient* clientDistribution_;
+
+/** Client-like distribution calculated based on the knowledge of the entire grid in case of a tiled domain */
+        CDistributionClient* clientDistributionTiled_;
+
 
 /** Server-like distribution calculated upon receiving indexes */
@@ -387,9 +424,15 @@
 
    template <int n>
-   void CGrid::maskField(const CArray<double,n>& field, CArray<double,1>& stored) const
+   void CGrid::copyTile(const CArray<double,n>& tileData, CArray<double,1>& storedData, int tileId)
+   {
+      this->copyTile_arr(tileData.dataFirst(), storedData, tileId);
+   }
+
+   template <int n>
+   void CGrid::maskField(const CArray<double,n>& field, CArray<double,1>& stored, bool isTiled) const
    {
 //#ifdef __XIOS_DEBUG
       if (this->getDataSize() != field.numElements())
-         ERROR("void CGrid::inputField(const  CArray<double,n>& field, CArray<double,1>& stored) const",
+         ERROR("void CGrid::maskField(const  CArray<double,n>& field, CArray<double,1>& stored) const",
                 << "[ Awaiting data of size = " << this->getDataSize() << ", "
                 << "Received data size = "      << field.numElements() << " ] "
@@ -397,5 +440,5 @@
                 << "Grid = " << this->getId())
 //#endif
-      this->maskField_arr(field.dataFirst(), stored);
+      this->maskField_arr(field.dataFirst(), stored, isTiled);
    }
 
Index: XIOS/trunk/src/test/test_tiled_domain.f90
===================================================================
--- XIOS/trunk/src/test/test_tiled_domain.f90	(revision 2131)
+++ XIOS/trunk/src/test/test_tiled_domain.f90	(revision 2131)
@@ -0,0 +1,197 @@
+PROGRAM test_tiled_domain
+
+  USE xios
+  USE mod_wait
+  IMPLICIT NONE
+  INCLUDE "mpif.h"
+  INTEGER :: rank
+  INTEGER :: size
+  INTEGER :: ierr
+
+  CHARACTER(len=*),PARAMETER :: id="client"
+  INTEGER :: comm
+  TYPE(xios_duration) :: dtime
+  CHARACTER(len=20) :: dtime_str
+  TYPE(xios_date) :: date
+  CHARACTER(len=20) :: date_str
+  CHARACTER(len=15) :: calendar_type
+  TYPE(xios_context) :: ctx_hdl
+  INTEGER,PARAMETER :: ni_glo=10!100
+  INTEGER,PARAMETER :: nj_glo=10!100
+  INTEGER,PARAMETER :: llm=5
+  DOUBLE PRECISION  :: lval(llm)=1, scalar = 5
+
+  integer, parameter :: ntiles=2
+  integer, dimension (ntiles) :: tile_ni, tile_nj, tile_ibegin, tile_jbegin
+  integer, dimension (ntiles) :: tile_data_ni, tile_data_nj, tile_data_ibegin, tile_data_jbegin  
+
+  TYPE(xios_field) :: field_hdl
+  TYPE(xios_fieldgroup) :: fieldgroup_hdl
+  TYPE(xios_file) :: file_hdl
+  LOGICAL :: ok
+
+  DOUBLE PRECISION,DIMENSION(ni_glo,nj_glo) :: lon_glo,lat_glo
+  DOUBLE PRECISION :: field_3d_glo(ni_glo,nj_glo,llm)
+  DOUBLE PRECISION,ALLOCATABLE :: field_3d(:,:,:)
+  DOUBLE PRECISION,ALLOCATABLE :: field_3d_tile(:,:,:)
+  INTEGER :: ni,ibegin,iend,nj,jbegin,jend
+  INTEGER :: i,j,l,ts,n
+  INTEGER :: ioffset, joffset
+
+  namelist /tile_data_def/ ioffset, joffset
+
+!!! MPI Initialization
+
+  CALL MPI_INIT(ierr)
+
+  CALL init_wait
+
+!!! XIOS Initialization (get the local communicator)
+
+  CALL xios_initialize(id,return_comm=comm)
+
+  CALL MPI_COMM_RANK(comm,rank,ierr)
+  CALL MPI_COMM_SIZE(comm,size,ierr)
+
+!!! Fill in global data array
+
+  DO l=1,llm
+    DO j=1,nj_glo
+      DO i=1,ni_glo
+        field_3d_glo(i,j,l)=(l-1)*ni_glo*nj_glo+(j-1)*ni_glo+(i-1)
+      ENDDO
+    ENDDO
+  ENDDO
+  ni=ni_glo ; ibegin=0
+
+!!! MPI domain decomposition
+
+  jbegin=0
+  DO n=0,size-1
+    nj=nj_glo/size
+    IF (n<MOD(nj_glo,size)) nj=nj+1
+    IF (n==rank) exit
+    jbegin=jbegin+nj
+  ENDDO
+
+  iend=ibegin+ni-1 ; jend=jbegin+nj-1
+
+!!! Fill in local data array
+
+  ALLOCATE(field_3d(ni,nj,llm))
+  field_3d(1:ni,1:nj,:)=field_3d_glo(ibegin+1:iend+1,jbegin+1:jend+1,:)
+
+!!! Tile domain decomposition
+  tile_ni(:)=ni
+  tile_ibegin(:)=0
+  tile_jbegin(1)=0
+  do n=0,ntiles-1
+    tile_nj(n+1)=nj/ntiles
+    if (n<MOD(nj,ntiles)) tile_nj(n+1)=tile_nj(n+1)+1
+  enddo
+
+  do n=2,ntiles
+    tile_jbegin(n)=tile_jbegin(n-1)+tile_nj(n-1)
+  enddo
+
+!!! Define tile data size
+
+  open(10,file='tile_data_def.nml')
+  read(10,nml=tile_data_def)
+  close(10)
+
+  ! Option 1: data correspond in size to a tile
+  if (ioffset == 0) then
+    tile_data_ni(:)=tile_ni(:)
+    tile_data_nj(:)=tile_nj(:)
+    tile_data_ibegin(:)=0
+    tile_data_jbegin(:)=0
+  
+  ! Option 2: masked data
+  else if (ioffset > 0) then
+    do n=1,ntiles
+      tile_data_ni(n)=tile_ni(n)-ioffset*2
+      tile_data_nj(n)=tile_nj(n)-joffset*2
+    enddo
+    tile_data_ibegin(:)=ioffset
+    tile_data_jbegin(:)=joffset
+
+  ! Option 3: data contain ghost zones
+  else
+    do n=1,ntiles
+      tile_data_ni(n)=tile_ni(n)+abs(ioffset)*2
+      tile_data_nj(n)=tile_nj(n)+abs(joffset)*2
+    enddo
+    tile_data_ibegin(:)=ioffset
+    tile_data_jbegin(:)=joffset
+  endif
+
+  CALL xios_context_initialize("test",comm)
+  CALL xios_get_handle("test",ctx_hdl)
+  CALL xios_set_current_context(ctx_hdl)
+
+  CALL xios_set_axis_attr("axis",n_glo=llm ,value=lval) ;
+  CALL xios_set_domain_attr("domain",ni_glo=ni_glo, nj_glo=nj_glo, ibegin=ibegin, ni=ni,jbegin=jbegin,nj=nj,type='curvilinear')
+  CALL xios_set_domain_attr("domain",ntiles=ntiles, tile_ni=tile_ni, tile_nj=tile_nj, tile_ibegin=tile_ibegin, tile_jbegin=tile_jbegin)
+  CALL xios_set_domain_attr("domain",tile_data_ni=tile_data_ni,tile_data_nj=tile_data_nj)
+  CALL xios_set_domain_attr("domain",tile_data_ibegin=tile_data_ibegin,tile_data_jbegin=tile_data_jbegin)
+
+  dtime%second = 3600
+  CALL xios_set_timestep(dtime)
+
+  ! The calendar is created as soon as the calendar type is defined. This way
+  ! calendar operations can be used before the context definition is closed
+  dtime%timestep = 1
+  dtime = 0.5 * dtime
+  
+  CALL xios_close_context_definition()
+  PRINT *,"close context definition: ok "
+
+  DO ts=1,10
+    CALL xios_update_calendar(ts)
+
+    do n=1,ntiles
+      ALLOCATE(field_3d_tile(tile_data_ibegin(n):tile_data_ibegin(n)+tile_data_ni(n)-1,&
+                             tile_data_jbegin(n):tile_data_jbegin(n)+tile_data_nj(n)-1,llm))
+      
+      if (ioffset == 0) then
+      ! Option 1: data correspond in size to a tile 
+      field_3d_tile(:,:,:)=field_3d(tile_ibegin(n)+1:tile_ibegin(n)+1+tile_ni(n),&
+                                  tile_jbegin(n)+1:tile_jbegin(n)+1+tile_nj(n),:)
+      
+      else if (ioffset > 0) then
+      ! Option 2: masked data
+      field_3d_tile(:,:,:)=field_3d(tile_ibegin(n)+1:tile_ibegin(n)+1+tile_ni(n),&
+                                  tile_jbegin(n)+1:tile_jbegin(n)+1+tile_nj(n),:)
+
+      else
+      ! Option 3: data contain ghost zones
+      field_3d_tile(:,:,:)=2.0
+      field_3d_tile(0:tile_ni(n)-1, 0:tile_nj(n)-1,:)=&
+                    field_3d(tile_ibegin(n)+1:tile_ibegin(n)+tile_ni(n),&
+                             tile_jbegin(n)+1:tile_jbegin(n)+tile_nj(n),:)
+      end if
+
+      CALL xios_send_field("field_3d",field_3d_tile,n-1)
+      DEALLOCATE(field_3d_tile)
+    enddo
+
+    CALL wait_us(5000) ;
+  ENDDO
+
+  CALL xios_context_finalize()
+
+  DEALLOCATE(field_3d)
+
+  CALL MPI_COMM_FREE(comm, ierr)
+
+  CALL xios_finalize()
+
+  CALL MPI_FINALIZE(ierr)
+
+END PROGRAM test_tiled_domain
+
+
+
+
+
